//rateAdjuster mechanism
//by Basilis Papapanagiotou and Giannis Zaoudis
//14-04-2009

#include "rateAdjuster.h"
#include <stdio.h>

//function to check the current loss_rate
void rateAdjuster::adjust(){
	//check if our loss_rate is bigger than a threshold (currently 10%)
	if(input > threshold){
		//if not adjust the power by a coefficient of our choice (currently 5%)
		output += coeff*output;
		//upper bound to prevent excessive consumption 
		if(output >= 0.1) output = 0.1;
		printf("RATE adjuster: Increase power!\n");
	}else if(input < (0.75*threshold)){
		//we have an area currently 7.5-10% where loss_rate is acceptable
		output -= coeff*output;
		//lower bound to prevent the base station from halting the transmission
		if(output <= 0.030) output = 0.031;
		printf("RATE adjuster: MEIONO to power!\n");
	}
	printf("RATE adjuster: to output einai %lf\n",output);fflush(stdout);
}
